// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#include "FiberHint.hpp"

#include "CallerEnvironment.hpp"
#include "Worker.hpp"

namespace emper {
template <CallerEnvironment callerEnvironment>
auto FiberHint::createNewWorkHint() -> FiberHint {
	if constexpr (callerEnvironment == CallerEnvironment::ANYWHERE) {
		return {emper::FiberSource::hintAq};
	}

	return {Worker::getCurrentWorkerId(), emper::FiberSource::hintWsq};
}
template auto FiberHint::createNewWorkHint<CallerEnvironment::EMPER>() -> FiberHint;
template auto FiberHint::createNewWorkHint<CallerEnvironment::ANYWHERE>() -> FiberHint;
}	 // namespace emper

auto operator<<(std::ostream& os, const emper::FiberHint& hint) -> std::ostream& {
	return os << "FiberHint{" << hint.getWorker() << ", " << hint.getSource() << "}";
}
