// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#include "FiberSource.hpp"

#include <iostream>

#include "Common.hpp"

auto operator<<(std::ostream& os, const emper::FiberSource& fiberSource) -> std::ostream& {
	switch (fiberSource) {
		case emper::FiberSource::local:
			return os << "local";
		case emper::FiberSource::mpscQueue:
			return os << "mpscQueue";
		case emper::FiberSource::stolen:
			return os << "stolen";
		case emper::FiberSource::io:
			return os << "io";
		case emper::FiberSource::ioStolen:
			return os << "ioStolen";
		case emper::FiberSource::anywhereQueue:
			return os << "anywhereQueue";
		case emper::FiberSource::hintWsq:
			return os << "hintWsq";
		case emper::FiberSource::hintAq:
			return os << "hintAq";
		default:
			DIE_MSG("Unknown FiberSource");
	}
}
