// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

namespace emper {
/*! Enum representing the different outcomes of a stealing attempt */
enum class StealingResult {
	Empty,		/*!< indicate there was nothing to steal*/
	LostRace, /*!< indicate the attempt to steal was unsuccessful because there was a concurrent
							 access and we lost the race */
	Stolen,		/*!< indicate a successful stealing attempt */
};
}	 // namespace emper
