// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Fischer
#pragma once

#include <ostream>

namespace emper::io {

enum class Operation {
	SEND = 0,
	RECV,
	CONNECT,
	ACCEPT,
	OPENAT,
	READ,
	WRITE,
	WRITEV,
	CLOSE,
	SHUTDOWN,
	LINK_TIMEOUT,
	TIMEOUT,
	CANCEL,
	MADVISE,
	NUMBER_OF_OPERATIONS
};

auto operator<<(std::ostream& os, const Operation& o) -> std::ostream&;

}	 // namespace emper::io
