// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

#include "Actor.hpp"
#include "Debug.hpp"	// for LogSubsystem, LogSubsystem::IO, Logger

class Runtime;
namespace emper::io {
class Future;
class IoContext;
}	 // namespace emper::io

namespace emper::io {
class SubmitActor : public Actor<Future *>, public Logger<LogSubsystem::IO> {
 private:
	IoContext &io;

 protected:
	void receive(Future *future) override;

 public:
	SubmitActor(IoContext &c, Runtime &runtime) : Actor(runtime), io(c) {}
};
}	 // namespace emper::io
