// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

namespace emper::sleep_strategy {

/**
 * @brief States a worker can have regarding the sleep strategy
 */
enum class SleeperState {
	Running,	/*!< The worker is in its dispatch loop */
	Sleeping, /*!< The worker is sleeping in the sleep strategy */
	Notified, /*!< The worker was notified an should (re-) execute its dispatch loop */
};

}	 // namespace emper::sleep_strategy
