// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

#include <cstddef>
#include <iostream>

namespace emper::sleep_strategy {
class WorkerStats {
	friend class Stats;
	friend auto operator<<(std::ostream& os, const WorkerStats& s) -> std::ostream&;

	size_t onNewWork = 0;
	size_t notify = 0;
	size_t notifications = 0;
	size_t skip = 0;
	size_t wakeup = 0;
	size_t wakeupDueToNotify = 0;

	auto operator+=(const WorkerStats& other) -> WorkerStats& {
		onNewWork += other.onNewWork;
		notify += other.notify;
		notifications += other.notifications;
		skip += other.skip;
		wakeup += other.wakeup;
		wakeupDueToNotify += other.wakeupDueToNotify;
		return *this;
	}
};

auto operator<<(std::ostream& os, const WorkerStats& s) -> std::ostream&;
}	 // namespace emper::sleep_strategy
