// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2022 Florian Schmaus, Florian Fischer
#include "WsDispatcher.hpp"

#include <optional>

#include "NextFiberResult.hpp"
#include "Runtime.hpp"	// for Runtime

class AbstractFiber;

void WsDispatcher::dispatchLoop() {
	while (true) {
		std::optional<NextFiberResult> next = runtime.nextFiber();
		if (!next) {
			dispatchLoopDoSleep();

			continue;
		}
		AbstractFiber* fiber = next->fiber;

		dispatch(fiber);

		recycle(fiber);
	}
}
