// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2022 Florian Schmaus
#include <iostream>

#include "BinaryPrivateSemaphore.hpp"
#include "Fibril.hpp"

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void waitOnBps(BPS* bps) { bps->wait(); }

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void forkFirstThenSignal() {
	Fibril fibril;
	BPS bps;

	fibril.fork(waitOnBps, &bps);

	bps.signal();

	fibril.join();
}

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril static void signalFirstThenFork() {
	Fibril fibril;
	BPS bps;

	bps.signal();

	fibril.fork(waitOnBps, &bps);

	fibril.join();
}

void emperTest() {
	std::cout << "####    Fork first, then signal\n";
	forkFirstThenSignal();

	std::cout << "####    Signal first, then fork\n";
	signalFirstThenFork();

	std::cout << "####    Return from emperTest()\n";
}
